var LocalStorageCache = /** @class */ (function () {
    function LocalStorageCache() {
    }
    LocalStorageCache.prototype.set = function (key, value) {
        try {
            localStorage.setItem(key, this.b64EncodeUnicode(value));
        }
        catch (ex) {
            // local storage is unavailable
        }
    };
    LocalStorageCache.prototype.get = function (key) {
        try {
            var configString = localStorage.getItem(key);
            if (configString) {
                return this.b64DecodeUnicode(configString);
            }
        }
        catch (ex) {
            // local storage is unavailable or invalid cache value in localstorage
        }
        return void 0;
    };
    LocalStorageCache.prototype.b64EncodeUnicode = function (str) {
        return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g, function (_, p1) {
            return String.fromCharCode(parseInt(p1, 16));
        }));
    };
    LocalStorageCache.prototype.b64DecodeUnicode = function (str) {
        return decodeURIComponent(Array.prototype.map.call(atob(str), function (c) {
            return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
        }).join(''));
    };
    return LocalStorageCache;
}());
export { LocalStorageCache };
